#!/usr/bin/env python


import sys
from optparse import OptionParser
from datetime import datetime
import xmlrpclib
import os
import re
import time
import struct
import StringIO
sys.path.append('/usr/lib/groovix-util/python/')
import ConfigParser
import groovix_lib


def pactimetick(pactimeserver,myversion,mypass,timezone,user,workstation,forceinit,exec_ack):

  rc=0
  #if not defined already, get from config file
  config=ConfigParser.ConfigParser()
  default_cfg = StringIO.StringIO("""\
[pactime]
noserver=0
countup=0
noserver_quota_s=30
noserver_threshold_y=30
noserver_threshold_o=10
noserver_threshold_r=5
  """)
  config.readfp(default_cfg)
  config.read("/etc/groovix/pactime.conf")
  noserver=int(config.get('pactime','noserver'))
  noserver_quota_s=int(config.get('pactime','noserver_quota_s'))
  if (myversion == None):
    myversion=config.get('pactime','customid')
  if (mypass == None):
    mypass=config.get('pactime','custompw')
  if (timezone == None):
    timezone=config.get('pactime','timezone')
  if (pactimeserver == None):
    pactimeserver=config.get('pactime','pactimeserver')

  if (user == None):
    user=os.environ['USER']

  if (workstation == None):
    #try:
    #  display=os.environ['DISPLAY']
    #except:
    #  display=":0"
    #match=re.search(r'\:*(\d)\.*(\d)*',display)
    #if match:
    #  display=match.group(1)

    #f=open('/etc/groovix/label', 'r')
    #workstation=(f.read()).strip()
    workstation=os.popen('groovix-get-parameter GX_LABEL').read().strip()
    #workstation=(f.read()).strip()+":"+display

  #mode where we just report how much time is used, not how much is remaining
  #in pactime_daemon, thresholds will be crossed going up instead of down
  #typically, this will be used with no quotas, set all to -1 in server settings or noserver_ local settings
  countup=int(config.get('pactime','countup'))
      

  if (noserver == True):
      usage_m=quota_m=usage_w=quota_w=usage_d=quota_d=-1
      exec_type=0
      exec_string=""
      override_session=-1
      needinit=changedworkstation=0
      ##sessionlimit=int(config.get('pactime','noserver_quota_s'))
      threshold_y=int(config.get('pactime','noserver_threshold_y'))
      threshold_o=int(config.get('pactime','noserver_threshold_o'))
      threshold_r=int(config.get('pactime','noserver_threshold_r'))
      quota_s=int(config.get('pactime','noserver_quota_s'))
      usage_s=int(get_session_usage(user))
  else: 
    try:
      s = xmlrpclib.ServerProxy(pactimeserver)
     
      [updaterc,updaterm,needinit,changedworkstation,usage_m,quota_m,usage_w,quota_w,usage_d,quota_d,usage_s,quota_s,override_session,threshold_y,threshold_o,threshold_r,exec_type,exec_string]=s.update(myversion,mypass,timezone,user,workstation,forceinit,exec_ack)
   
    #except xmlrpclib.ProtocolError: (OR socket.error: (110, 'Connection timed out')
    # to debug what is failing, change to let the exception slip:
    #except ZeroDivisionError:
    except:
       rm="Could not connect to "+pactimeserver+", time remaining is unknown"
       #don't deny them if server can't be reached for any reason
       rc=1
       lm=str(groovix_lib.formatExceptionInfo())
       needinit=changedworkstation=threshold_y=threshold_o=threshold_r=lowest_remaining=usage_s=exec_type=0
       exec_string=""
       return rc,rm,lm,lowest_remaining,usage_s,needinit,changedworkstation,threshold_y,threshold_o,threshold_r,exec_type,exec_string

    if (  updaterc != 0):
       #we communicated successfully, but the return code indicates a problem
       rm="Error in "+pactimeserver+", time remaining is unknown"
       #don't deny them if server can't be reached for any reason
       rc=2
       lm=updaterm
       needinit=changedworkstation=threshold_y=threshold_o=threshold_r=lowest_remaining=usage_s=0
       return rc,rm,lm,lowest_remaining,usage_s,needinit,changedworkstation,threshold_y,threshold_o,threshold_r,exec_type,exec_string
  
  #end noserver=0

  #rm is return message, short
  rm=''
  #sm is short message, no longer used
  #sm=''
  #lm is long message, full details
  lm=''

##if session length is overriden, all we care about is session length, all other quotas are ignored
#  if (override_session > -1):
#    quota_s=override_session;

  #put period values into a matrix for easy processing
  #remaining is 4th column, max days in time period is 5th column
  matrix=[["Monthly",quota_m,usage_m,0,31],["Weekly ",quota_w,usage_w,0,7],["Daily  ",quota_d,usage_d,0,1],["Session",quota_s,usage_s,0,1]]
  for row in matrix:
   if (row[1] != -1):
    row[3]=row[1]-row[2]
    if (row[2] >= row[1]):
      #sm+=row[0]+" Time Exceeded, "
      lm+=row[0]+" quota of "+str(row[1])+" is exceeded! \n"
      rc=12
    else:
      lm+=row[0]+" quota: %4i/%-4i used, %4i remaining.\n" % (row[2],row[1],row[3])
      #sm+=row[0]+" "+str(row[2])+'/'+str(row[1])+', '
   else:
    #max possible minutes in time period
    row[3]=row[4]*24*60

  if (override_session > -1):
      lowest_remaining=override_session-usage_s
      #lm+="Session Length is in override mode"
      if (lowest_remaining <= 0 ):
        lm+="Time Override Session Length of "+str(override_session)+" has been exceeded."
        rc=13
      else:
        #only time override value matters now
        rc=0
        lm+="Time Override: %4i/%-4i used, %4i remaining.\n" % (usage_s,override_session,lowest_remaining)
        
  else:
    lowest_remaining=min(matrix[0][3],matrix[1][3],matrix[2][3],matrix[3][3])

  if (countup == True):
    if (usage_s == 1):
        rm=str(usage_s)+" minute used in this session"
    else:
        rm=str(usage_s)+" minutes used in this session"
  else:
    if (lowest_remaining == 1):
        rm=str(lowest_remaining)+" minute remaining in this session"
    else:
        rm=str(lowest_remaining)+" minutes remaining in this session"
    #now just use really short message for rm and then full details in long message lm
    #sm+="You have"+ lowest_remaining+" minutes available."
  

  #write out minutes left to file for caching purposes so other programs like screenlock and cmon can reference this
  #TODO: cmon should be able to read this database directly, don't have to send this info to the server every time
  tfilename='/var/lib/groovix/session-info/'+user+'.time-infocache'
  try:
    outfile=open(tfilename,'w')
  except:
  #except ZeroDivisionError:
    #if we're not running as root, or user has never been officially logged in (creating '/var/lib/groovix/pac/userinfo/'+str(user) ) 
    #, then use /tmp
    filepath=os.path.join('/tmp','.pactimeinfo-'+str(user))
    outfile=open(filepath,'w')

  outfile.write(rm)
  outfile.write("\n")
  outfile.write(lm)
  #outfile.write(str(lowest_remaining)+' remaining.')
  outfile.close

  return rc,rm,lm,lowest_remaining,usage_s,needinit,changedworkstation,threshold_y,threshold_o,threshold_r,exec_type,exec_string


def get_session_usage(username):
    current_time=datetime.now()
    login_time=get_login_time(username)
    time_diff=current_time-login_time
    #add on a minute since other database-based time usage is set to 1 minute upon login
    return 1+time_diff.days*24*60+time_diff.seconds/60

def get_login_time(username):
    #relies on timestamp written during /etc/gdm/PostLogin/Default, not ideal,
    #but the approach commented out below has problems too
    try:
      last_login_time=os.path.getmtime("/var/lib/groovix/session-info/"+username+".effective-login-time")
      last_local_time=time.localtime(last_login_time)
      last_login_time=datetime(*last_local_time[:6])
    except:
      print "could not find user login stamp at "+"/var/lib/groovix/session-info/"+username+".effective-login-time"
      try:
        last_login_time=get_login_time_utmp(username)
      except:
        last_login_time=0
    #print last_local_time
    return last_login_time

def get_login_time_utmp(username):
    #use only if other method fails, utmp shows all "login" processes which include xterms run by the user
    #we could take the first entry for the user, utmp seems to order them oldest first
    rec = WTmpRecord()
    #f = open("/var/log/wtmp","rb")
    f = open("/var/run/utmp","rb")
    while True:
        bin = f.read(rec.size())
        if len(bin) != rec.size():
            break
        rec.unpack(bin)
        #if rec.type == 7:
        if True:
          if rec.User == username :
          #if True:
            #print " %1d %-8s %-12s %-24s %-20s %5d %08x" % \ (rec.type, rec.User, rec.Line, time.strftime("%a %Y-%m-%d %H:%M:%S",time.localtime(rec.time)), rec.Hostname, rec.PID, rec.addr)
            #print "exit status is "
            #print rec.exit_status

            last_local_time=time.localtime(rec.time)
           #print last_local_time
            last_login_time=datetime(*last_local_time[:6])
            #print last_login_time
            break
        if bin == "":
          break

    f.close()
    return last_login_time

class WTmpRecord:
    fmt = "hI32s4s32s256siili4l20s";
    _fieldnames = ["type","PID","Line","inittab","User","Hostname",
                    "exit_status", "session", "time", "addr" ]
    def __init__(self):
        self._rec_size = struct.calcsize(self.fmt)
    def size(self):
        return self._rec_size
    def unpack(self, bin_data):
        rec = struct.unpack(self.fmt, bin_data)
        self._rec = []
        for i in range(len(rec)):
            if i in (2,3,4,5):
                # remove character zeros from strings
                self._rec.append( rec[i].split("\0")[0] )
            else:
                self._rec.append(rec[i])
        return self._rec
    def fieldnames(self):
        return self._fieldnames
    def __getattr__(self,name):
        return self._rec[self._fieldnames.index(name)]


def run():

  parser = OptionParser()
  parser.add_option("-t", "--timezone", dest="timezone", help="timezone of local workstation")
  parser.add_option("-v", "--version", dest="myversion", help="customer version code")
  parser.add_option("-p", "--password", dest="mypass", help="customer password")
  parser.add_option("-u", "--user", dest="user",  help="user name")
  parser.add_option("-w", "--workstation", dest="workstation", help="local workstation name including :$DISPLAY")
  parser.add_option("-c", "--checkonly", action="store_true", dest="checkonly", default=False, help="just check time usage, don't update")
  parser.add_option("-f", "--forceinit", action="store_true", dest="forceinit", default=False, help="force a new session initialization")
  parser.add_option("--status", dest="status", default="update", help="usually login, update, or logout")
  parser.add_option("--exec_ack",dest="exec_ack",default=False, action="store_true",help="explicitly set exec_ack to true")
  parser.add_option("--server", dest="pactimeserver", help="full url to pactime server script, include everything from http:// to .py ")

  (options, args) = parser.parse_args()

  #  print options

  myversion=options.myversion
  mypass=options.mypass
  timezone=options.timezone
  user=options.user
  workstation=options.workstation
  checkonly=options.checkonly
  status=options.status
  pactimeserver=options.pactimeserver
  exec_ack=options.exec_ack
  forceinit=options.forceinit

  rc,message,lm,lowest_remaining,usage_s,needinit,changedworkstation,threshold_y,threshold_o,threshold_r,exec_type,exec_string=pactimetick(pactimeserver,myversion,mypass,timezone,user,workstation,forceinit,exec_ack)
  print message
  print "Details:"
  print lm
  exit(rc)

if __name__ == "__main__":
  run()
